package netproj.hosts;

import java.util.logging.Logger;

import netproj.skeleton.Packet;

public class FTPHost extends Host {
	private int packetSize = 0;
	private static final Logger logger = Logger.getLogger(FTPHost.class.getCanonicalName());
	
	/**
	 * Creates a basic host, an endpoint in the network, with default gateway set to 0.
	 */
	public FTPHost(int inputBuffSize, int outputBuffSize, int address, int packetSize) {
		super(inputBuffSize, outputBuffSize, address);
		this.packetSize = packetSize;		
	}

	@Override
	public void processPacket(Packet msg) {
		logger.fine("Packet " + msg + " received at " + Integer.toHexString(getAddress()));
	}
	protected final void sendData(int dest, int size, int ttl) {
		int packetCount = size / this.packetSize;
		for(int i=0; i < packetCount; i++) {
			Packet packet = new Packet(this.getAddress(),dest, this.packetSize, ttl);
			sendPacket(packet, this.getDefaultGateway());
		}
		// are we done? (was it not a multiple of the packet size)
		if (size - packetCount * this.packetSize > 0) {
			Packet packet = new Packet(this.getAddress(),dest, size - packetCount * this.packetSize, ttl);			
			sendPacket(packet, this.getDefaultGateway());
		}
	}

	
}
