package netproj.hosts;

import java.util.logging.Logger;

import netproj.skeleton.Packet;

/**
 * A host that logs all its incoming packets and drops them.
 */
public class SimpleHost extends Host {
	private static final Logger logger = Logger.getLogger(Pinger.class.getCanonicalName());
	
	public SimpleHost(int address, int outputBuffSize) {
		super(10, outputBuffSize, address);
	}
	
	@Override
	public void processPacket(Packet msg) {
		logger.fine("Packet " + msg + " received at " + Integer.toHexString(getAddress()));
	}
}
